﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr263_1
{
    // Базовый класс: 
    class Alpha {
        // Поле:
        protected int code;
        // Конструктор: 
        public Alpha(int n){ 
            code = n;
        }
        // Виртуальный метод: 
        public virtual void show() {
            Console.WriteLine("Класс Alpha: " + code); 
        }
    }

    // Производный класс: 
    class Bravo: Alpha {
        // Конструктор:
        public Bravo(int n): base(n){}
        // Переопределение метода: 
        public override void show() {
            Console.WriteLine("Класс Bravo: " + code);
        }

    }

    // Производный класс: 
    class Charlie: Bravo {
        // Конструктор:
        public Charlie(int n): base(n){}
        // Переопределение метода: 
        public override void show() {
            Console.WriteLine("Класс Charlie: " + code);
        }
    }

    // Обобщенный класс с ограничением на обобщенный параметр: 
    class MyClass<T> where T: Alpha {
        // Поле - ссылка на объект: 
        public Alpha obj;
        // Конструктор обобщенного класса: 
        public MyClass(T t) {
            // Ссылка на объект: 
            obj = t;
            // Вызов метода: 
            obj.show();
        }
    }

    // Главный класс: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объектов обычных классов:
            Alpha A = new Alpha(100);
            Bravo B = new Bravo(200);
            Charlie C = new Charlie(300);
            // Создание объектов на основе обобщенного класса:
            MyClass<Alpha> objA = new MyClass<Alpha>(A);
            MyClass<Bravo> objB = new MyClass<Bravo>(B);
            MyClass<Charlie> objC = new MyClass<Charlie>(C);
            MyClass<Alpha> objD = new MyClass<Alpha>(C);
            // Задержка:
            Console.ReadLine();
        }
    }
}
